from tkinter import *
from threeD import *
#■Zバッファ描画
def drawZbuffer(canvas, a,L0, R, G, B):
    #screen 座標変換
    Num=len(a.p)
    pp=[0 for i in range(Num)]
    for i in range(Num): pp[i]=screen(a.p[i])
    #各種ベクトル設定
    V=unit(a.p[0]-v0)                       #視線方向
    L=unit(a.p[0]-L0)                       #照明方向
    N=unit((a.p[0]-a.p[2])%(a.p[1]-a.p[3])) #法線方向
    #明るさによる色の設定
    D=(((N)*L0))/(length(N)*length(L0))     #明るさ
    if   D<0 : D=0
    elif D>1 : D=1
    R= int(D*float(R)); G= int(D*float(G)); B= int(D*float(B))
    C="#%02X%02X%02X" % (R,G,B)
    # screen座標範囲の設定
    y_max=int(pp[0].y); y_min=int(pp[0].y)
    s0=0; s1=0; n= Num-1
    for i in range(Num):
        if   y_min> int(pp[i].y): y_min=int(pp[i].y); s0=s1=i
        elif y_min==int(pp[i].y): s1=i
        if y_max<pp[i].y        : y_max= int(pp[i].y)
    for y in range(y_min,y_max+1):
        if pp[(s0-1+n)%n].y<y : s0=(s0-1+n)% n
        if pp[(s1+1)  %n].y<y : s1=(s1+1)  % n
        s2 = (s1+1) % n; s3 = (s0-1+n)% n
        p0 = pp[s0]; p1 = pp[s1]; p2 = pp[s2]; p3 = pp[s3]
        p4 = interpolate(p1, p2, y-int(p1.y), int(p2.y)-y) #p1,p2を補間
        p5 = interpolate(p0, p3, y-int(p0.y), int(p3.y)-y) #p0,p3を補間
        for x in range(int(p4.x), int(p5.x+1)):
            p=interpolate(p4,p5,int(float(x)-p4.x), int(p5.x-float(x)))
            if z_buff[x][y]<p.z: #以前描画した画素より手前にあれば描画
                drawPointXY(canvas, x,y,C)
                z_buff[x][y]=p.z
#■メインプログラム
root= Tk()
root.title("3D Methods(Z buffering)")
canvas=Canvas(root,width=500,height=400)
canvas.pack()
z_buff=[[-1e30 for j in range(400)] for i in range(500)]
init2D(500,400)
origin(250,200)
V0= Point(500,500,500)                  #視点
L0= Point(0,500,1000)                   #照明光
setview(V0)
#drawAxisXYZ(canvas)
#b=circle_xy(36)                         #円形(補助線用)
a=circle_xz(18)                         #トーラスの生成
aa=a*50
Fig=revolve_z(move(100,0,0)*aa,36)
Num=len(Fig.polygon)
for i in range(Num):
    drawZbuffer(canvas,Fig.polygon[i],L0, 0x77, 0x77, 0xFF)
a=circle_xz(18,0,180)                   #球体の生成
Fig=move(0,0,50)*revolve_z(a*70,36)
Num=len(Fig.polygon)
for i in range(Num):
    drawZbuffer(canvas,Fig.polygon[i],L0, 0xFF,0x77, 0xFF)
#a=circle_xz(18);aa=a*50
#drawLine(canvas, move(100,0,0)*aa, 'red')
#drawLine(canvas, b*150, 'red')
